/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package de.hsrm.cs.swt.swingjtable;

import java.util.ArrayList;
import javax.swing.JOptionPane;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

/**
 *
 * @author Wolfgang Knauf
 */
public class MainForm extends javax.swing.JFrame {

    /**Modell der Tabelle - muss in Membervariablen gespeichert werden, damit
     * Abrufen/Setzen der Selection klappt.
     */
    private TableModelStudent modelStudenten;
    /**
     * Creates new form MainForm
     */
    public MainForm() {
        initComponents();

        //Erzeugen des Datenmodells für die Tabelle:
        ArrayList<Student> listData = new ArrayList<Student>();
        Student stud1 = new Student();
        stud1.setMatrikelnummer(1234567);
        stud1.setVorname("Hans");
        stud1.setNachname("Meier");
        listData.add(stud1);

        Student stud2 = new Student();
        stud2.setMatrikelnummer(333444);
        stud2.setVorname("Sybille");
        stud2.setNachname("Müller");
        listData.add(stud2);

        Student stud3 = new Student();
        stud3.setMatrikelnummer(568923);
        stud3.setVorname("Otto");
        stud3.setNachname("Huber");
        listData.add(stud3);

        //Erzeugen des TableModell:
        this.modelStudenten = new TableModelStudent(listData);
        //Befüllen der Tabelle:
        this.jTableStudenten.setModel(modelStudenten);

        //es gibt kein Event "Auswahländerung" auf dem JTable. Das geht über das SelectionModel:
        this.jTableStudenten.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
            @Override
            public void valueChanged(ListSelectionEvent e) {
                jTableStudentenSelectionChanged(e);
            }
        });

        //
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPaneStudenten = new javax.swing.JScrollPane();
        jTableStudenten = new javax.swing.JTable();
        jLabelSelected = new javax.swing.JLabel();
        jTextFieldSelected = new javax.swing.JTextField();
        jButtonSelectMueller = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jScrollPaneStudenten.setViewportView(jTableStudenten);

        jLabelSelected.setText("Gewählt:");

        jButtonSelectMueller.setText("\"Müller wählen\"");
        jButtonSelectMueller.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSelectMuellerActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(32, 32, 32)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jButtonSelectMueller)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addGroup(layout.createSequentialGroup()
                            .addComponent(jLabelSelected)
                            .addGap(30, 30, 30)
                            .addComponent(jTextFieldSelected))
                        .addComponent(jScrollPaneStudenten, javax.swing.GroupLayout.PREFERRED_SIZE, 324, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(44, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPaneStudenten, javax.swing.GroupLayout.PREFERRED_SIZE, 217, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabelSelected)
                    .addComponent(jTextFieldSelected, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jButtonSelectMueller)
                .addContainerGap(19, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonSelectMuellerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSelectMuellerActionPerformed
        //Finde Student "Müller":
        int indexMueller = -1;
        //Schleife beenden wenn einer gefunden wurde.
        for (int row = 0; row < this.modelStudenten.getRowCount() && indexMueller == -1; row++)
        {
            Student studentAktuell = this.modelStudenten.getStudentAt(row);
            if (studentAktuell.getNachname().equals("Müller") == true)
            {
                indexMueller = row;
                
            }
        }
        //Fehlermeldung wenn nicht gefunden:
        if (indexMueller == -1)
        {
            JOptionPane.showConfirmDialog(this, "Fehler: kein Student namens 'Müller' gefunden.");
            return;
        }
        this.jTableStudenten.getSelectionModel().setSelectionInterval(indexMueller, indexMueller);
    }//GEN-LAST:event_jButtonSelectMuellerActionPerformed

    private void jTableStudentenSelectionChanged (ListSelectionEvent e)
    {
        String studentenSelected = "";
        
        int[] selectedRows = this.jTableStudenten.getSelectedRows();
        for(int rowSelected : selectedRows)
        {
            Student student = this.modelStudenten.getStudentAt(rowSelected);
            if (studentenSelected.length() > 0)
            {
                studentenSelected += ", ";
            }
            studentenSelected += student.toString();
        }
        this.jTextFieldSelected.setText(studentenSelected);
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonSelectMueller;
    private javax.swing.JLabel jLabelSelected;
    private javax.swing.JScrollPane jScrollPaneStudenten;
    private javax.swing.JTable jTableStudenten;
    private javax.swing.JTextField jTextFieldSelected;
    // End of variables declaration//GEN-END:variables
}
