/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package de.hsrm.cs.swt.swingjtable;

import java.util.List;

/**
 * Modell der Studententabelle.
 *
 * @author Wolfgang Knauf
 */
public class TableModelStudent extends javax.swing.table.AbstractTableModel {

    /**
     * Liste der angezeigten Studenten
     */
    private List<Student> studenten;

    /**
     * Konstruktor, dem eine Liste von Studenten als Grundlage des TableModel
     * übergeben wird.
     *
     * @param studenten Liste der anzuzeigenden Studenten, not null
     */
    public TableModelStudent(List<Student> studenten) {
        if (studenten == null) {
            throw new IllegalArgumentException("Parameter 'studenten' darf nicht NULL sein");
        }

        this.studenten = studenten;
    }

    @Override
    public String getColumnName(int column) {
        switch (column) {
            case 0:
                return "Matrikelnummer";
            case 1:
                return "Nachname";
            case 2:
                return "Vorname";

            default:
                throw new IllegalArgumentException("Spaltenindex " + column + " ist ungültig");
        }
    }

    @Override
    public int getRowCount() {

        return this.studenten.size();
    }

    @Override
    public int getColumnCount() {
        return 3;
    }

    @Override
    public java.lang.Class<?> getColumnClass(int column) {
        switch (column) {
            case 0:
            case 1:
            case 2:
                return String.class;
            default:
                throw new IllegalArgumentException("Spaltenindex " + column + " ist ungültig");
        }
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        Student studi = this.studenten.get(rowIndex);

        switch (columnIndex) {
            case 0:
                return studi.getMatrikelnummer();
            case 1:
                return studi.getNachname();
            case 2:
                return studi.getVorname();
            default:
                throw new IllegalArgumentException("Spaltenindex " + columnIndex + " ist ungültig");
        }
    }
    
    public Student getStudentAt (int index)
    {
        return this.studenten.get(index);
    }
            
}
